var ParsersFactory = function (configure) {
    this._file = configure.file;
    this._type = configure.type;
}

ParsersFactory.prototype.create = function (callback) {
    //@todo check callback
    _this = this;
    
    /* Set up the AJAX call to load XML data */
    var XMLLoader = $.ajax({
        url : this._file,
        type : "GET",
        dataType : "xml"
    });

    /* AJAX Success, start it up */
    XMLLoader.done(function(data){
        var _parser=null;
        switch (_this._type) {
	        case VIEW_TYPE.EXPERIMENT:
	            _parser = new ExperimentParser(data);
	            break;
	        case VIEW_TYPE.RESULTS:
	            _parser = new ResultsParser(data);
	            break;
            case VIEW_TYPE.ADVANCED_SETTINGS:
                _parser = new AdvancedSettingsParser(data);
                break;
            default:
                //@todo throw an exception
                break;
        };
        callback(_parser, null);
    });
    
    /* AJAX failure */
    XMLLoader.fail(function(err){
        alert("Load Failed");
        callback(null, err);
    });
}

/*var Presentation = function () {

}

Presentation.prototype.show = function (object) {
    object.buildHTML();
}*/