(function() {
  'use strict';

  var loadedAt = Date.now();
  var board1, board2;

  var coords = {
    'self': 171,
    //'white':171,
    'other': 358
  };

  var GRAPH_COLOR = '#4056A6';
  var GRAPH_COLOR_2 = '#FF0000';
  var STROKE_COLOR = '#6d6d6d';
  var TEXT_COLOR = 'rgb(102,102,102)';


  var BOTTOM_BORDER = 380;
  var TOP_BORDER = -25;
  var WIDTH_OF_BAR = 125;

  // Update graph
  var updateGraph = function( data ) {
    Object.keys( coords ).forEach( function( key ){
      setBar( document.querySelector( 'polygon.' + key ), coords[key], data[key] );
      if (key === 'self') {
        setBar( document.querySelectorAll( 'polygon.' + key )[1], coords[key], data[key] );
      }
      setText( document.querySelector( '.text_labels_y.' + key ), data[key] );
    } );
    //console.log(data);
    var alt_text = "People not responsible for misfortune equals " + data.self + ", People responsible for misfortune equals " + data.other;
    var content = $('#student-result-img');
    content.attr('alt', 'Your results: ' + alt_text);
  };

  var setText = function( node, value ) {
    var height = Math.round( value / 10 * ( BOTTOM_BORDER - TOP_BORDER ) );

    node.textContent = value.toFixed(2);
    node.style.top = ( BOTTOM_BORDER - height ) - 22;
  };

  var setBar = function( node, coord, value ) {
    var height = Math.round( value / 10 * ( BOTTOM_BORDER - TOP_BORDER ) );

    var points = [ coord + ',' + BOTTOM_BORDER,
      coord + ',' + ( BOTTOM_BORDER - height ),
      ( coord + WIDTH_OF_BAR ) + ',' + ( BOTTOM_BORDER - height ),
      ( coord + WIDTH_OF_BAR ) + ',' + BOTTOM_BORDER ];

    node.setAttribute( 'points', points.join(' ') );
  };



  // Update graph
//  var updateGraphUser = function( node, max, data ) {
//    var board = ( node === 'G2Dbox1') ? board1 : board2;
//    var answers;
//
//      answers = data;
//
//    var axisX, axisY;
//
//    if ( board ) {
//      G2D.G2DGraph.freeBoard( board );
//    }
//
//    // Init graph
//    board = G2D.G2DGraph.initBoard( node, { boundingbox: [-0.22, max, 3, -0.5], showCopyright: false, showNavigation: true } );
//    board.suspendUpdate();
//
//    var f = [];
//    // Create axis
//    axisY = board.createElement( 'line', [
//      [0, 0],
//      [0, 1]
//    ], { fixed: true, strokeColor: 'white', strokeWidth: 0, highlight: false } );
//    axisX = board.createElement( 'line', [
//      [0, 0],
//      [1, 0]
//    ], { fixed: true, strokeColor: STROKE_COLOR, strokeWidth: 1, highlight: false } );
//
//    // Create ticks
//    board.create( 'ticks', [axisY], { fixed: true, opacity: 0.5, minorTicks: 0, ticksDistance: 1, majorHeight: 6, drawLabels: false, highlight: false, tickEndings: [0, 250], strokeWidth: 1, strokeColor: STROKE_COLOR } );
//
//
//    var namesColumn = ['People not responsible for misfortune','People responsible for misfortune'];
//
//    Object.keys( answers ).forEach( function( key, i ) {
//      f.push( answers[key ] );
//      //board.create( 'text', [i + 2, 0, key], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//    } );
//
//
//    for( var i =0; i<3; i++){
//      board.create( 'text', [i + 1, 0.1, namesColumn[i]], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels", anchorX: "middle", color: TEXT_COLOR, fontSize: 10 } );
//    }
//    for ( var k = 0; k < f.length; k++ ) {
//      board.create( 'text', [k + 1, f[k] + 0.3, f[k]], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels_y", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//    }
//
//    for ( var j = 0; j < 10; j++ ) {
//      board.create( 'text', [-0.12, j, j], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels_y", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//    }
//
//
//    // Create chart
//    board.createElement( 'chart', [f[0]], { fixed: true, chartStyle: 'bar', width: 0.6, color: GRAPH_COLOR, fillOpacity: 1 } );
//    board.createElement( 'chart', [0,f[1]], { fixed: true, chartStyle: 'bar', width: 0.6, color: GRAPH_COLOR_2, fillOpacity: 1 } );
//
//    board.unsuspendUpdate();
//  };
//
//
//
//  // Update graph
//  var updateGraph = function( node, data ) {
//    var board = board2;
//    var answers;
//
//      answers = results;
//
//    var axisX, axisY;
//
//    if ( board ) {
//      G2D.G2DGraph.freeBoard( board );
//    }
//    // Init graph
//    board = G2D.G2DGraph.initBoard( node, { boundingbox: [-0.3, 10, 12, -0.5], showCopyright: false, showNavigation: true } );
//    board.suspendUpdate();
//
//    var f = [];
//    // Create axis
//    axisY = board.createElement( 'line', [
//      [0, 0],
//      [0, 1]
//    ], { fixed: true, strokeColor: 'white', strokeWidth: 0, highlight: false } );
//    axisX = board.createElement( 'line', [
//      [0, 0],
//      [1, 0]
//    ], { fixed: true, strokeColor: STROKE_COLOR, strokeWidth: 1, highlight: false } );
//
//    // Create ticks
//    board.create( 'ticks', [axisY], { fixed: true, opacity: 0.5, minorTicks: 0, ticksDistance: 1, majorHeight: 6, drawLabels: false, highlight: false, tickEndings: [0, 250], strokeWidth: 1, strokeColor: STROKE_COLOR } );
//
//    var namesColumn = ['Benefits','Costs','Alternatives','Invesment'];
//
//    Object.keys( answers ).forEach( function( key, i ) {
//      f.push( answers[key ] );
//      //board.create( 'text', [i + 2, 0, key], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//    } );
//
//
//    for( i =0; i<4; i++){
//      board.create( 'text', [i*3 + 2.5, 0, namesColumn[i]], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//    }
//
//    var j = 0;
//    for ( var k = 0; k < f.length; k++ ) {
//      if ( k > 1 && k < 4 ) {
//        j = 1;
//      }
//      else if ( k > 3 ) {
//        j = 2;
//      }
//      // board.create( 'text', [k + 2 + j, f[k] + 2, f[k]+'%'], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels_y", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//
//    }
//
//    for ( j = 0; j < 10; j++ ) {
//      board.create( 'text', [-0.12, j * 10, j * 10], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels_y", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
//    }
//
//    var f_blue = [], f_green = [], f_red = [];
//    f_red.push( 0 );
//    f_blue.push( 0 );
//    f_green.push( 0 );
//    for ( var i = 0; i < 6; i = i + 3 ) {
//      f_blue.push( 0 );
//      f_blue.push( f[i] );
//      f_blue.push( 0 );
//      f_blue.push( 0 );
//      f_blue.push( 0 );
//     // f_blue.push( 0 );
//
//      f_red.push( 0 );
//     f_red.push( 0 );
//     f_red.push( f[i + 1] );
//      f_red.push( 0 );
//      f_red.push( 0 );
//     // f_red.push( 0 );
//
//      f_green.push( 0 );
//      f_green.push( 0 );
//      f_green.push( 0 );
//      f_green.push( f[i + 2] );
//      f_green.push( 0 );
//     // f_green.push( 0 );
//
//    }
//    // Create chart
//    board.createElement( 'chart', [f_blue], { fixed: false, chartStyle: 'bar', width: 1, color: GRAPH_COLOR, fillOpacity: 1 } );
//    board.createElement( 'chart', [f_red], { fixed: true, chartStyle: 'bar', width: 1, color: GRAPH_COLOR_2, fillOpacity: 1 } );
//    board.createElement( 'chart', [f_green], { fixed: true, chartStyle: 'bar', width: 1, color: GRAPH_COLOR_3, fillOpacity: 1 } );
//
//    board.unsuspendUpdate();
//  };

  function isBecomingVisible() {
    if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null && window.parent.player.experiment.lastUpdated > loadedAt ) {
      updateGraph( window.parent.player.experiment.results );
      $('#G2Dbox1' ).show();
      $('.no-results' ).hide();
    }
  }

  if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null  ) {
    updateGraph( window.parent.player.experiment.results );
    $('#G2Dbox1' ).show();
    $('.no-results' ).hide();
  }

  //updateGraph( 'G2Dbox2', 5.4 );
  window.isBecomingVisible = isBecomingVisible;


})();