(function() {
  'use strict';

  $(document).ready(function () {
    $('*').focus(function () {
      console.log(this);
    })
  })

  var loadedAt = Date.now();
  var resultsNew = {};
  var $showResult = $( '.show-results' );
  var $trialAnswer = $( '.trial-answer' );

  var coords = {
    'practice_trial': 88,
    'practice_trial-say': 137,
    'unanimous_group': 234,
    'unanimous_group-say': 283,
    'dissenter_present': 380,
    'dissenter_present-say': 429
  };

  var BOTTOM_BORDER = 369;
  var TOP_BORDER = 31;
  var WIDTH_OF_BAR = 85;

  // Update result
  var updateResult = function() {
    $( '.no-results' ).hide();
    $showResult.show();
    for ( var i = 0; i < 3; i++ ) {
      if ( window.parent.player.experiment.results[i] == true ) {
        $trialAnswer[i].textContent = 'Yes';
      }
      else {
        $trialAnswer[i].textContent = 'No';
        console.log( $trialAnswer[i] );
        $trialAnswer[i].setAttribute( 'style', 'color:rgb(0, 0, 255)' );
      }
    }
  };

  var updateGraph = function( data ) {
    Object.keys( coords ).forEach( function( key ) {
      setBar( document.querySelector( 'polygon.' + key ), coords[key], data[key] );
      setText( document.querySelector( '.text_labels_y.' + key ), data[key] );
    } );
  };

  var setText = function( node, value ) {
    if ( value == 0 ) {
      node.textContent = '0%';
      node.style.top = ( BOTTOM_BORDER) - 22;
    }
  };

  var setBar = function( node, coord, value ) {
    if ( value == 0 ) {
      var points = [ coord + ',' + BOTTOM_BORDER,
        coord + ',' + ( BOTTOM_BORDER  ),
        ( coord + WIDTH_OF_BAR ) + ',' + ( BOTTOM_BORDER ),
        ( coord + WIDTH_OF_BAR ) + ',' + BOTTOM_BORDER ];
      node.setAttribute( 'points', points.join( ' ' ) );
    }
  };

  function isBecomingVisible() {
    if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null && window.parent.player.experiment.lastUpdated > loadedAt ) {
      var resultsNew = {
        'practice_trial': window.parent.player.experiment.results[0],
        'practice_trial-say': window.parent.player.experiment.results[1],
        'unanimous_group': window.parent.player.experiment.results[2],
        'unanimous_group-say': window.parent.player.experiment.results[3],
        'dissenter_present': window.parent.player.experiment.results[4],
        'dissenter_present-say': window.parent.player.experiment.results[5]
      };
      updateGraph( resultsNew );
      $( '.no-results' ).hide();
      $( '#G2Dbox1' ).show();
    }
  }

  if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null ) {
    var resultsNew = {
      'practice_trial': window.parent.player.experiment.results[0],
      'practice_trial-say': window.parent.player.experiment.results[1],
      'unanimous_group': window.parent.player.experiment.results[2],
      'unanimous_group-say': window.parent.player.experiment.results[3],
      'dissenter_present': window.parent.player.experiment.results[4],
      'dissenter_present-say': window.parent.player.experiment.results[5]

    };
    updateGraph( resultsNew );
    $( '.no-results' ).hide();
    $( '#G2Dbox1' ).show();
  }

  window.isBecomingVisible = isBecomingVisible;


})();