(function() {
  'use strict';

  var loadedAt = Date.now();
  var board1, board2;

  var results = {
    'practice trial': 1,
    'practice trial-say': 55,
    'unanimous group': 40,
    'unanimous group-say': 16,
    'dissenter present': 48,
    'dissenter present-say': 16
  };

  var $showResult = $( '.show-results' );
  var $trialAnswer = $( '.trial-answer' );

  var GRAPH_COLOR = '#4056A6';
  var GRAPH_COLOR_2 = '#FF0000';
  var STROKE_COLOR = '#6d6d6d';
  var TEXT_COLOR = 'rgb(102,102,102)';

  // Update graph
  var updateGraph = function( node, data ) {
    var board = board2;
    var answers;
    if ( data ) {
      answers = data;
    }
    else {
      answers = results;
    }
    var axisX, axisY;

    if ( board ) {
      G2D.G2DGraph.freeBoard( board );
    }

    // Init graph
    board = G2D.G2DGraph.initBoard( node, { boundingbox: [-0.3, 100, 12, -8], showCopyright: false, showNavigation: true } );
    board.suspendUpdate();

    var f = [];
    // Create axis
    axisY = board.createElement( 'line', [
      [0, 0],
      [0, 1]
    ], { fixed: true, strokeColor: 'white', strokeWidth: 0, highlight: false } );
    axisX = board.createElement( 'line', [
      [0, 0],
      [1, 0]
    ], { fixed: true, strokeColor: STROKE_COLOR, strokeWidth: 1, highlight: false } );

    // Create ticks
    board.create( 'ticks', [axisY], { fixed: true, opacity: 0.5, minorTicks: 0, ticksDistance: 10, majorHeight: 6, drawLabels: false, highlight: false, tickEndings: [0, 250], strokeWidth: 1, strokeColor: STROKE_COLOR } );

    var namesColumn = ['Ignore comments','Show surprise','Confront comments'];

    Object.keys( answers ).forEach( function( key, i ) {
      f.push( answers[key ] );
      //board.create( 'text', [i + 2, 0, key], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
    } );


    for( i =0; i<3; i++){
      board.create( 'text', [i*3 + 2.5, 0, namesColumn[i]], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
    }

    var j = 0;
    for ( var k = 0; k < f.length; k++ ) {
      if ( k > 1 && k < 4 ) {
        j = 1;
      }
      else if ( k > 3 ) {
        j = 2;
      }
      board.create( 'text', [k + 2 + j, f[k] + 2, f[k]+'%'], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels_y", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );

    }

    for ( j = 0; j < 10; j++ ) {
      board.create( 'text', [-0.12, j * 10, j * 10], { fixed: true, highlight: false, highlightCssClass: "text_labels", cssClass: "text_labels_y", anchorX: "middle", color: TEXT_COLOR, fontSize: 14 } );
    }

    var f_blue = [], f_red = [];
    f_red.push( 0 );
    f_blue.push( 0 );
    for ( var i = 0; i < 6; i = i + 2 ) {
      f_red.push( f[i] );
      f_red.push( 0 );
      f_red.push( 0 );
      f_blue.push( 0 );
      f_blue.push( f[i + 1] );
      f_blue.push( 0 );
      console.log(answers);
    }
    // Create chart
    board.createElement( 'chart', [f_blue], { fixed: false, chartStyle: 'bar', width: 1, color: GRAPH_COLOR, fillOpacity: 1 } );
    board.createElement( 'chart', [f_red], { fixed: true, chartStyle: 'bar', width: 1, color: GRAPH_COLOR_2, fillOpacity: 1 } );

    board.unsuspendUpdate();
  };

  function isBecomingVisible() {
    if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null && window.parent.player.experiment.lastUpdated > loadedAt ) {
      $( '.no-results' ).hide();
      $showResult.show();
      for ( var i = 0; i < 3; i++ ) {
        if ( window.parent.player.experiment.results[i] == true ) {
          $trialAnswer[i].textContent = 'Yes';
        }
        else {
          $trialAnswer[i].textContent = 'No';
          console.log( $trialAnswer[i]);
          $trialAnswer[i].setAttribute('style','color:rgb(0, 0, 255)');
        }
      }
    }
  }

  if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null ) {
    $( '.no-results' ).hide();
    $showResult.show();
    for ( var i = 0; i < 3; i++ ) {
      if ( window.parent.player.experiment.results[i] == true ) {
        $trialAnswer[i].textContent = 'Yes';
      }
      else {
        $trialAnswer[i].textContent = 'No';
        console.log( $trialAnswer[i]);
        $trialAnswer[i].setAttribute('style','color:rgb(0, 0, 255)');
      }
    }
  }

  //updateGraph( 'G2Dbox2' );
  window.isBecomingVisible = isBecomingVisible;


})();