(function() {
  'use strict';

  var loadedAt = Date.now();

  var FIRST_RESULT_ALT_PART = 'Two bar graphs display the results of your work from the experiment.'
                              + '  The first graph is labeled "Male results" and has three vertical bars'
                              + ' on the X-axis.  The first bar represents the intelligent rating, the second bar'
                              + ' represents the competent rating, and the third bar represents the smart rating.'
                              + '  The Y-axis is labeled with the number of rating from 1 to 9. ';

  var SECOND_RESULT_ALT_PART = 'The second graph is labeled "Female results" and has three vertical bars on the X-axis.'
                               + '  The first bar represents the intelligent rating, the second bar represents the'
                               + ' competent rating, and the third bar represents the smart rating.  The Y-axis is labeled'
                               + ' with the number of rating from 1 to 9. ';

  var coords = {
    'intelligent': 131,
    'competent': 273,
    'smart': 415
  };

  var BOTTOM_BORDER = 380;
  var TOP_BORDER = 16;
  var WIDTH_OF_BAR = 85;

  // Update graph
  var updateGraph2 = function( data ){

    Object.keys( coords ).forEach( function( key ) {
      setBar( document.querySelector( '#G2Dbox2 polygon.' + key ), coords[key], data[key] );
      setText( document.querySelector( '#G2Dbox2 .text_labels_y.' + key ), data[key] );
    } );

    // second experiment's values
    var alt_text = SECOND_RESULT_ALT_PART + 'Intelligent equals ' + data.intelligent + ', Competent equals ' + data.competent + ', Smart equals ' + data.smart;

    $('#result-aria-image-2').attr('alt', alt_text);

  }

  var updateGraph = function( data ) {
    console.log(data)
    Object.keys( coords ).forEach( function( key ) {
      setBar( document.querySelector( '#G2Dbox1 polygon.' + key ), coords[key], data[key] );
      setText( document.querySelector( '#G2Dbox1 .text_labels_y.' + key ), data[key] );
    } );

    // first experiment's values
    var alt_text = FIRST_RESULT_ALT_PART + 'Intelligent equals ' + data.intelligent + ', Competent equals ' + data.competent + ', Smart equals ' + data.smart;
    $('#result-aria-image-1').attr('alt', alt_text);
  };

  var setText = function( node, value ) {
    var height = Math.round( value / 9 * ( BOTTOM_BORDER - TOP_BORDER ) );

    node.textContent = value;
    node.style.top = ( BOTTOM_BORDER - height ) - 22;
  };

  var setBar = function( node, coord, value ) {
    var height = Math.round( value / 9 * ( BOTTOM_BORDER - TOP_BORDER ) );

    var points = [ coord + ',' + BOTTOM_BORDER,
      coord + ',' + ( BOTTOM_BORDER - height ),
      ( coord + WIDTH_OF_BAR ) + ',' + ( BOTTOM_BORDER - height ),
      ( coord + WIDTH_OF_BAR ) + ',' + BOTTOM_BORDER ];

    node.setAttribute( 'points', points.join( ' ' ) );
  };


  function isBecomingVisible() {
    if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null && window.parent.player.experiment.lastUpdated > loadedAt ) {

      updateGraph( window.parent.player.experiment.results1 );
      updateGraph2( window.parent.player.experiment.results2 );

      $( '#G2Dbox2' ).show();
      $( '#G2Dbox1' ).show();
      $( '.no-results' ).hide();
    }
  }

  if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null ) {
    updateGraph( window.parent.player.experiment.results1 );
    updateGraph2( window.parent.player.experiment.results2 );
    $( '#G2Dbox1' ).show();
    $( '#G2Dbox2' ).show();
    $( '.no-results' ).hide();
  }

  window.isBecomingVisible = isBecomingVisible;


})();