(function() {
  'use strict';

  var choiceStudent = ['As mentioned on the previous screen, write around 5 sentences pertaining to why you think the student does so well in school.',
      'As mentioned on the previous screen, write around 5 sentences pertaining to why you think the student does so poorly in school.'],
    trialStudent = ['Sincere', 'Trustworthy', 'Intelligent', 'Affectionate', 'Curious', 'Assertive', 'Hardworking', 'Enthusiastic'];
  var isPassed = true;

  //random choice between (well and poorly) students
  var randomChoice = function() {
    return Math.floor( Math.random() * (2 - 1 + 1) );
  }
  var randomNum = randomChoice();


  Array.prototype.shuffle = function() {
    for ( var i = this.length - 1; i > 0; i-- ) {
      var num = Math.floor( Math.random() * ( i + 1 ) );
      var d = this[ num ];
      this[ num ] = this[ i ];
      this[ i ] = d;
    }
    return this;
  };

  var Trial = function() {
    this.trialNum = 8;
    this.sectionCondition = 1;
    this.i = 0;
    this.data = [];
    this.answers = [];
    this.names = [];
    this.results = {
      'self': 0,
      'other': 0
    };
  };

  Trial.prototype.init = function() {
    window.onkeypress = this.startKeyListener.bind( this, 'begin' );
  };

  Trial.prototype.startKeyListener = function( mode, evt ) {
    var keyCode = evt.keyCode || evt.which;
    var str = String.fromCharCode( keyCode );
    if ( str === ' ' && isPassed) {
      this.start( mode );
    }
  };


  Trial.prototype.pause = function() {
    $('.choice-student' ).html('In making appraisals of another person, it can also be important to understand the personality of the person making these judgments.  For each of the traits listed below, rate it in terms of how well it describes you as a person using the 0 to 9 scale.');
    $('.container-answer' ).remove();
    this.$textContainer.show();
    this.$trial.show();
    this.$trialCounter.show();

    window.onkeypress = this.startKeyListener.bind( this, 'after pause' );
  };

  Trial.prototype.start = function( mode ) {

    $('.answer button' ).click(function(){
      if($('.answer textarea' ).val() != ''){
        this.pause();
      } else {
        $('.error' ).remove();
        $('.answer textarea' ).after('<p class="error" style="margin-left: 10px; font-style: italic; font-size: 12px;">You must enter an answer.</p>');
        $('.answer textarea' ).focus();
      }
    }.bind(this));

    if ( mode === 'begin' ) {

      if ( window.opener.sectionCondition ) {
        this.sectionCondition = window.opener.sectionCondition;
      }
      else if ( window.parent.sectionCondition ) {
        this.sectionCondition = window.parent.sectionCondition;
      }
      window.parent.choiceStudent = randomNum;
      window.opener.choiceStudent = randomNum;
      console.log(randomNum);

      this.$trialCounterCurrent = $( '.trial-counter .current' );
      this.$trialCounter = $( '.trial-counter' );
      this.trialTextArray = [];
      this.$trialStudent = $('.trialStudent');
      this.$trialText = $('.trial-text');
      this.$trial = $('.trial');
      this.$pauseText = $( '.pause-text' );
      this.$textContainer = $( '.text-container' );
      this.$textContainerTop = $( '.text-container-top' );
      this.$closeButton = $( '.close-button' );
      this.$membersAnswers = $( '.members-answers' );
      for ( var i = 0; i < 8; i++ ) {
        this.trialTextArray[i] = $( trialStudent[i] );
      }
      $( '.choice-container' ).show();
      $( '.choice-student' ).html( choiceStudent[randomNum] );
    }
    else {
      this.$membersAnswers.show();
      this.$trialCounter.show();
      //$( '.choice-container' ).hide();
      $('.choice-student' ).removeAttr("tabindex");

      this.$trialText.show();

      window.onkeypress = this.keyListener.bind( this );

      this.showTrial(mode);
    }
    //this.$pauseText.hide();
    this.$textContainer.show();
    $( '.text-container' ).hide();


  };

  Trial.prototype.saveResult = function() {

    this.$trialCounter.hide();
    this.$trial.hide();
    this.$membersAnswers.hide();
    this.$textContainerTop.hide();
    this.$closeButton.show();
    $( '.choice-container' ).hide();

    this.results = {
      'intelligent': this.answers[2],
      'hardworking': this.answers[6]
    };

    window.results = this.results;
  };

  Trial.prototype.showTrial = function( mode ) {
    if ( mode === 'begin' ) {
      return false;
    }
    else if(isPassed){
      if ( this.i < this.trialNum && isPassed) {
        this.$trialStudent.html(trialStudent[this.i]+' ');
        this.$textContainerTop.hide();
        var html = '';
        this.$membersAnswers.html( html );
        this.i++;
        this.$trialCounterCurrent.text( this.i );

        if(this.i>7){
          this.$textContainer.hide();
          isPassed = false;
        }
      }
    }
  };

  Trial.prototype.addAnswer = function( answer ) {
    this.answers.push( answer );
  };

  Trial.prototype.keyListener = function( event ) {
    var keyCode = event.keyCode || event.which;
    var str;

    str = String.fromCharCode( keyCode );

    if ( '99887766554433221100'.indexOf( str ) > -1 ) {
      ( str === '9' || str === '9' ) && ( this.addAnswer( 9 ) );
      ( str === '8' || str === '8' ) && ( this.addAnswer( 8 ) );
      ( str === '7' || str === '7' ) && ( this.addAnswer( 7 ) );
      ( str === '6' || str === '6' ) && ( this.addAnswer( 6 ) );
      ( str === '5' || str === '5' ) && ( this.addAnswer( 5 ) );
      ( str === '4' || str === '4' ) && ( this.addAnswer( 4 ) );
      ( str === '3' || str === '3' ) && ( this.addAnswer( 3 ) );
      ( str === '2' || str === '2' ) && ( this.addAnswer( 2 ) );
      ( str === '1' || str === '1' ) && ( this.addAnswer( 1 ) );
      ( str === '0' || str === '0' ) && ( this.addAnswer( 0 ) );
      if ( this.i === 8 ) {
        this.$textContainer.hide();
        this.saveResult();
      }
      else {
        this.showTrial();
      }
    }
  };

  var trial = new Trial();

  trial.init();

})();