(function() {
  'use strict';

  var loadedAt = Date.now();

  var coords = {
    persistent: 117,
    stubborn: 407
  };
  var colors = {
    Persistent: '#4056A6',
    Stubborn: '#B22222'
  };

  var BOTTOM_BORDER = 367;
  var TOP_BORDER = 33;
  var WIDTH_OF_BAR = 96;

  // Update graph
  var setText = function( node, value ) {
    var height = Math.round( value / 9 * ( BOTTOM_BORDER - TOP_BORDER ) );

    node.textContent = value;
    node.style.top = ( BOTTOM_BORDER - height ) - 22;
  };

  var createBar = function( node, coord, value, color ) {
    var height = Math.round( value / 9 * ( BOTTOM_BORDER - TOP_BORDER ) );

    var points = [ coord + ',' + BOTTOM_BORDER,
      coord + ',' + ( BOTTOM_BORDER - height ),
      ( coord + WIDTH_OF_BAR ) + ',' + ( BOTTOM_BORDER - height ),
      ( coord + WIDTH_OF_BAR ) + ',' + BOTTOM_BORDER ];

    node.setAttribute( 'points', points.join(' ') );
    node.setAttribute( 'fill', color );
  };

  // Update graph
  var updateGraph = function( data ) {
    Object.keys( coords ).forEach( function( key ){
      createBar( document.querySelector( 'polygon.' + key ), coords[key], data[key], colors[data.word] );
      setText( document.querySelector( '.text_labels_y.' + key ), data[key] );
    } );

    var alt_text = "Donald is Persistent equals " + data.persistent + ", Donald is Stubborn equals " + data.stubborn;
    $('#student-result-img').attr('alt', 'Your results: ' + alt_text + '.');
  };

  function isBecomingVisible() {
    if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null && window.parent.player.experiment.lastUpdated > loadedAt ) {
      updateGraph( window.parent.player.experiment.results );
      $('.no-results' ).hide();
      $('#G2Dbox' ).show();
    }
  }

  if ( window.parent.player.experiment && window.parent.player.experiment.lastUpdated !== null  ) {
    updateGraph( window.parent.player.experiment.results );
    $('.no-results' ).hide();
    $('#G2Dbox' ).show();
  }

  window.isBecomingVisible = isBecomingVisible;


})();